com.google.appengine.api.socket.dev

## Class LocalDatagramSocket

- java.lang.Object
- - com.google.appengine.api.socket.dev.LocalDatagramSocket

-     public class LocalDatagramSocket
      extends java.lang.Object

  Implements the actual datagram socket support for the dev server.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected LocalSocketService` | `socketService`
    `protected java.util.concurrent.atomic.AtomicLong` | `streamReceiveOffset`
    `protected java.util.concurrent.atomic.AtomicLong` | `streamSendOffset`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AcceptReply` | `accept(AcceptRequest request)`
    `protected byte[]` | `addrAsBytes(java.net.InetAddress address)`
    `BindReply` | `bind(BindRequest request)`
    `java.io.IOException` | `close()` Closes a socket but returns thrown exceptions.
    `CloseReply` | `close(CloseRequest request)`
    `ConnectReply` | `connect(ConnectRequest request)`
    `CreateSocketReply` | `createSocket(CreateSocketRequest request)`
    `GetPeerNameReply` | `getPeerName(GetPeerNameRequest request)`
    `java.lang.String` | `getSocketDescriptor()` Returns the socket descriptor.
    `GetSocketNameReply` | `getSocketName(GetSocketNameRequest request)`
    `GetSocketOptionsReply` | `getSocketOptions(GetSocketOptionsRequest request)`
    `ListenReply` | `listen(ListenRequest request)`
    `protected com.google.apphosting.api.ApiProxy.ApplicationException` | `newAppException(ErrorCode code, java.lang.String message)`
    `protected com.google.apphosting.api.ApiProxy.ApplicationException` | `newAppExceptionAndClose(ErrorCode code, java.lang.String message)`
    `protected com.google.apphosting.api.ApiProxy.ApplicationException` | `newNotImplementedException(java.lang.String method)`
    `ReceiveReply` | `receive(ReceiveRequest request)`
    `SendReply` | `send(SendRequest request)`
    `SetSocketOptionsReply` | `setSocketOptions(SetSocketOptionsRequest request)`
    `ShutDownReply` | `shutDown(ShutDownRequest request)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### streamReceiveOffset

          protected final java.util.concurrent.atomic.AtomicLong streamReceiveOffset

    - #### streamSendOffset

          protected final java.util.concurrent.atomic.AtomicLong streamSendOffset

    - #### socketService

          protected final LocalSocketService socketService

  - ### Method Detail

    - #### close

          public java.io.IOException close()

      Closes a socket but returns thrown exceptions.

    - #### bind

          public BindReply bind(BindRequest request)

    - #### getSocketName

          public GetSocketNameReply getSocketName(GetSocketNameRequest request)

    - #### getPeerName

          public GetPeerNameReply getPeerName(GetPeerNameRequest request)

    - #### connect

          public ConnectReply connect(ConnectRequest request)

    - #### listen

          public ListenReply listen(ListenRequest request)

    - #### accept

          public AcceptReply accept(AcceptRequest request)

    - #### shutDown

          public ShutDownReply shutDown(ShutDownRequest request)

    - #### close

          public CloseReply close(CloseRequest request)

    - #### send

          public SendReply send(SendRequest request)

    - #### receive

          public ReceiveReply receive(ReceiveRequest request)

    - #### createSocket

          public CreateSocketReply createSocket(CreateSocketRequest request)

    - #### getSocketDescriptor

          public java.lang.String getSocketDescriptor()

      Returns the socket descriptor.

    - #### setSocketOptions

          public SetSocketOptionsReply setSocketOptions(SetSocketOptionsRequest request)

    - #### getSocketOptions

          public GetSocketOptionsReply getSocketOptions(GetSocketOptionsRequest request)

    - #### addrAsBytes

          protected byte[] addrAsBytes(java.net.InetAddress address)

    - #### newAppException

          protected com.google.apphosting.api.ApiProxy.ApplicationException newAppException(ErrorCode code,
                                                                                            java.lang.String message)

    - #### newAppExceptionAndClose

          protected com.google.apphosting.api.ApiProxy.ApplicationException newAppExceptionAndClose(ErrorCode code,
                                                                                                    java.lang.String message)

    - #### newNotImplementedException

          protected com.google.apphosting.api.ApiProxy.ApplicationException newNotImplementedException(java.lang.String method)